unit WarmsForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus;

type

  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Warm1: TMenuItem;
    Run1: TMenuItem;
    Exit1: TMenuItem;
    procedure Exit1Click(Sender: TObject);
    procedure Run1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TWarmThread = class(TThread)
   private
     color:TColor;
     x,y:integer;
     form:TForm1;
   public
     constructor Create(color:TColor;y:integer;form:TForm1;suspended:boolean);
     procedure execute;override;
     procedure draw;
     procedure hide;

  end;

var
  Form1: TForm1;
procedure drawWarm(form:TForm;Color:TColor;x,y:integer);stdcall;external 'warm.dll';
implementation

{$R *.dfm}

procedure TForm1.Exit1Click(Sender: TObject);
begin
 Application.Terminate;
// Close;
end;

procedure TForm1.Run1Click(Sender: TObject);
var warm1,warm2,warm3:TWarmThread;
begin
 warm1 := TWarmThread.create(clBlue,50,self,true);
// warm2 := TWarmThread.create(clRed,height div 2,self,true);
// warm3 := TWarmThread.create(clGreen,height - 50,self, true);
 warm1.resume;
// warm2.resume;
// warm3.resume;
end;

{ TWarmThread }

constructor TWarmThread.Create(color: TColor;y:integer;form:TForm1; suspended: boolean);
begin
 inherited create(suspended);
 self.form:=form;
 self.x := 0;
 self.y := y;
 self.color := color;
end;

procedure TWarmThread.draw;
begin
 form.Canvas.Pen.Color := color;
 drawWarm(form,x,y);
end;

procedure TWarmThread.execute;
var i:integer;
begin
  for i:=0 to Form1.Width - 10 do
  begin
   x:=i;
   draw;
   sleep(10);
   hide;
  end;
end;

procedure TWarmThread.hide;
begin
 form.Canvas.Pen.Color := form1.Color;
 drawWarm(form,x,y);
end;

end.
